#![no_std]
#![no_main]
#![feature(abi_x86_interrupt)]
#![feature(associated_type_defaults)]
#![allow(internal_features)]
#![feature(ptr_internals)]
#![feature(allocator_api)]

use alloc::vec::Vec;

extern crate alloc;

#[macro_use]
mod logger;
mod interrupts;
mod gdt;
mod utils;
#[macro_use]
mod events;
mod mem;




#[no_mangle]
extern "C" fn kmain(mb2_info_addr: usize) -> ! {
    // Init
    logger::init(log::LevelFilter::Trace).unwrap();
    gdt::init();
    interrupts::init_idt();
    utils::enable_nxe_bit();
    utils::enable_write_protect_bit();
    
    mem::init(mb2_info_addr);

    let mut a = Vec::new();
    

    a.push(6);
    a.push(9);
    a.push(4);
    a.push(2);
    a.push(0);
    
    log::error!("{:?}", a); 


    
    // EVENTMAN.lock().add_listener(events::Event::Ps2KeyPress(None), |k| {
    //    let Event::Ps2KeyPress(v) = k else {panic!()};
    //
    //    log::debug!("Keypress event received! ({:?})", v.unwrap());
    //   Ok(())
    // });

    // let (level_4_page_table, _) = Cr3::read();
    // println!("Level 4 page table at: {:?}", level_4_page_table.start_address());
    log::info!("end of work");

    utils::hcf();
}


#[panic_handler]
fn panic(pi: &core::panic::PanicInfo) -> ! {
    log::error!("{pi}");
    utils::hcf();
}


